# Demonstration of why you should not do "from mymodule import *"
# Demo code: "Modules 101", PyCon AU 2013

# Let's import everything from the mymath module
from mymath import *

# Let's calculate a circle's circumference, using our definition of pi which has
# limited precision
print "With limited precision (pi = {0}), circumference = {1}".format(pi, circumference(5))

# Let's improve the precision of pi (which we imported from mymath)
# but this will NOT improve the precision of the circumference() function as it is
# using mymath.pi, which is NOT the same variable as pi
pi = 3.1415

print "Improved precision? (pi = {0}), circumference = {1}".format(pi, circumference(5))

# Now let's explicitly import mymath and improve the precision of mymath.pi, which
# does give us improved circumference precision

import mymath
mymath.pi = 3.1415

print "Improved precision? (pi = {0}), circumference = {1}".format(mymath.pi, circumference(5))

print "pi != mymath.pi; here are the IDs: {0} and {1}".format(pi, mymath.pi)

# Wherever possible, avoid global variables and especially importing them only to
# redefine them!

